package org.example.stack;

import java.util.Scanner;

public class ReversePolishNotationCalculator {

    public static void main(String[] args) {
        IStack<Integer> stack = new Stack<>(new Integer[10]);
        Scanner scanner = new Scanner(System.in);
        boolean working = true;
            while (working) {
                try {
                    String token = scanner.next();
                    switch (token) {
                        case "+" -> {
                            int a = stack.pop();
                            int b = stack.pop();
                            stack.push(a + b);
                        }
                        case "-" -> {
                            int a = stack.pop();
                            int b = stack.pop();
                            stack.push(a - b);
                        }
                        case "*" -> {
                            int a = stack.pop();
                            int b = stack.pop();
                            stack.push(a * b);
                        }
                        case "/" -> {
                            int a = stack.pop();
                            int b = stack.pop();
                            stack.push(a / b);
                        }
                        case "quit" -> working = false;
                        default -> stack.push(Integer.valueOf(token));
                    }
                } catch (StackFullException e) {
                    System.out.println("Stack is full");
                    e.printStackTrace();
                } catch (StackEmptyException e) {
                    System.out.println("Stack is empty");
                    e.printStackTrace();
                } catch (NumberFormatException e) {
                    System.out.println("Not a number");
                    e.printStackTrace();
                }
            }
        try {
            System.out.println(stack.pop());
        } catch (StackEmptyException e) {
            System.out.println("No value at stack at the end");
        }
    }
}
